Unit afe0z_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AA01Z_p;

procedure afe0z(var CR :Array of Extended; var CI :Array of Extended;
                var B :Array of Extended; N :Integer);

implementation

procedure afe0z(var CR :Array of Extended; var CI :Array of Extended;
                var B :Array of Extended; N :Integer);
var
I :Integer;
CRI,CII,UR,UI,C,VR,VI :Extended;
label
_1,_2,_3;
begin
B[0] := 0.0;
CR[0] := 1.0;
CI[0] := 0.0;
UR := 1.0;
UI := 0.0;
if ( N = 1 )
 then goto _3;
for I:=2 to N do
 begin
  CRI := CR[I-1];
  CII := CI[I-1];
  C := AA01Z(CRI,CII);
  B[I-1] := C;
  if ( C = 0.e0 )
   then goto _1;
  CRI := CRI/C;
  CII := CII/C;
  VR := CRI*UR-CII*UI;
  VI := CRI*UI+CII*UR;
  UR := VR;
  UI := VI;
  CR[I-1] := VR;
  CI[I-1] := VI;
  goto _2;
_1:
  CR[I-1] := 1.0;
  CI[I-1] := 0.0;
  UR := 1.0;
  UI := 0.0;
_2:
 end;
_3:
end;

end.
